/* ------------------------------------------------------------------------ */
/* get_dir.c			             (GPL) 1997,98  Belgie  Belgium */
/*							    Staf Wagemakers */
/* ------------------------------------------------------------------------ */
#include <stddef.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include "get_dir.h"
int compare(const char **c1,const char **c2)
{
  return strcmp (*c1,*c2);
}
struct dir_data* get_dir(char *path)
{
 struct dirent *ep;
 struct stat stat_buf;
 struct dir_data *data;
 DIR    *dp;
 char   *s;
 dp=opendir(path);
 if (dp==NULL) return(NULL);
  data=(struct dir_data*) xmalloc(sizeof(struct dir_data));
  data->file=data->dir=NULL;
  data->files=data->dirs=0;
  while (ep=readdir(dp)) {
       data->file=(char **) xrealloc(data->file,(data->files+1)*sizeof(char **)); 
       data->dir=(char **) xrealloc(data->dir,(data->dirs+1)*sizeof(char **));
       s=(char *) xmalloc(sizeof(path)+sizeof(ep->d_name));
       strcpy(s,path);
       strcat(s,ep->d_name);
       if (stat(s,&stat_buf)==-1) {
             data->file[data->files]=(char *) xmalloc(sizeof(ep->d_name));
	     strcpy (data->file[data->files++],ep->d_name);
         }
	else { 
            if (S_ISDIR(stat_buf.st_mode)) { 
              data->dir[data->dirs]=(char *) xmalloc(sizeof(ep->d_name)); 
	      strcpy (data->dir[data->dirs++],ep->d_name);
	      }
	      else {
	          data->file[data->files]=(char *) xmalloc(sizeof(ep->d_name));
	          strcpy (data->file[data->files++],ep->d_name);
              }
	 }     
       xfree(s);
       };
   (void) closedir (dp);
   qsort (data->dir,data->dirs,sizeof(char **),compare);
   qsort (data->file,data->files,sizeof(char **),compare);
   return(data);
}
void get_dir_free(struct dir_data *data)
{
unsigned long l;
xfree(data->file);
for (l=0;l<data->dirs;l++) xfree(data->dir[l]);
xfree(data->dir);
xfree(data);
}
